 {
******************************************************
  USB Disk Ejector
  Copyright (c) 2006, 2007, 2008 Ben Gorman
  Http://quick.mixnmojo.com
******************************************************
}
{
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}


{$R MainResources.res}

program USBDiskEject;

uses
  Forms,
  sysutils,
  dialogs,
  formMain in 'formMain.pas' {Mainfrm},
  uDriveEjector in 'uDriveEjector.pas',
  uDiskEjectConst in 'uDiskEjectConst.pas',
  formOptions in 'formOptions.pas' {Optionsfrm},
  formAbout in 'formAbout.pas' {Aboutfrm},
  uCustomHotKeyManager in 'uCustomHotKeyManager.pas',
  uDiskEjectOptions in 'uDiskEjectOptions.pas',
  uProcessAndWindowUtils in 'uProcessAndWindowUtils.pas',
  uDiskEjectUtils in 'uDiskEjectUtils.pas';

var
  SilentSwitch, strTempDrive: string;
  boolSilent: boolean;
  Ejector: TDriveEjector;
  EjectErrorCode: integer;
  CardEject: boolean;

begin
  Application.Initialize;

  //TODO!!!!!!!!!!!!!!!!!!  Fix this with proper switches ************************
  CardEject:= true;
  //******************************************************************************

  // ? Param
  if FindCmdLineSwitch('?', true) then
  begin
    showMessage(str_Question);
    exit;
  end;

  //Set booleans
  if FindCmdLineSwitch('SILENT', true) then
    boolSilent:=true
  else
    boolSilent:=false;

  // SILENT Param
  if boolSilent then
    silentswitch:='/SILENT '
  else
    silentswitch:=''; //no silent switch

  // REMOVETHIS Param
  if options.CommandLine_RemoveThis then
  begin
    StartInMobileMode(SilentSwitch + '/NOSAVE ' + options.CommandLine_Param_ShowEject + options.CommandLine_Param_CloseApps + options.CommandLine_Param_CloseAppsForce + '/REMOVELETTER ' + ExtractFileDrive(application.ExeName)[1]);
    exit;
  end;


  // REMOVELETTER Param
  if options.CommandLine_RemoveLetter then
  begin
    //Eject the letter then exit
    {ShowMessage('Remove letter ' + RemoveLetterParam);}

    //Check if trying to eject drive that program is running from
    //Check if mobile is false - in case somehow temp folder is on the drive you're trying to eject
    if (options.DriveRunningFrom = options.CommandLine_Param_RemoveLetter) and
       (options.MobileMode = false) then
    begin
      StartInMobileMode(SilentSwitch + '/NOSAVE ' + options.CommandLine_Param_ShowEject + options.CommandLine_Param_CloseApps + options.CommandLine_Param_CloseAppsForce + '/REMOVELETTER ' + options.CommandLine_Param_RemoveLetter);
      exit;
    end;

    if options.MobileMode then  //wait 1.5 seconds for program that started this one to exit
      Sleep(1500);

    Ejector:=TDriveEjector.Create;
    try
      if Ejector.RemoveDrive(options.CommandLine_Param_RemoveLetter, EjectErrorCode, options.CommandLine_ShowEject, CardEject, options.CommandLine_CloseApps, options.CommandLine_CloseAppsForce) = false then
        if options.CommandLine_ShowEject=false then //if its true then windows shows its own message
          case EjectErrorCode of
            REMOVE_ERROR_UNKNOWN_ERROR:   ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_UNKNOWN_ERROR);
            REMOVE_ERROR_DRIVE_NOT_FOUND: ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_DRIVE_NOT_FOUND);
            REMOVE_ERROR_DISK_IN_USE:     ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_DISK_IN_USE);
            REMOVE_ERROR_NO_CARD_MEDIA:   ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_NO_CARD_MEDIA);
            REMOVE_ERROR_WINAPI_ERROR:    ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_WINAPI_ERROR);
        end;
    finally
      Ejector.free;
    end;

    if options.MobileMode then //cleanup
      CreateCleanupBatFileAndRun;

    exit;
  end;


  // REMOVENAME Param
  if options.CommandLine_RemoveName then
  begin
    //Find the drive name in RemoveDriveNameParam, eject that drive then exit
    //ShowMessage('Remove name ' + RemoveNameParam);

    if options.MobileMode then  //wait 1.5 seconds for program that started this one to exit
      Sleep(1500);


    strTempDrive:=MatchNameToDriveLetter(options.CommandLine_Param_RemoveName);
    //Check if trying to eject drive that program is running from
    //Check if mobile is false - in case somehow temp folder is on the drive you're trying to eject
    if (options.DriveRunningFrom = strTempDrive) and
       (options.MobileMode = false) then
    begin
      StartInMobileMode(SilentSwitch + '/NOSAVE ' + options.CommandLine_Param_ShowEject + options.CommandLine_Param_CloseApps + options.CommandLine_Param_CloseAppsForce + '/REMOVELETTER ' + strTempDrive);
      exit;
    end;


    if strTempDrive <> '' then
    begin
      Ejector:=TDriveEjector.Create;
      try
        if Ejector.RemoveDrive(strTempDrive, EjectErrorCode, options.CommandLine_ShowEject, CardEject, options.CommandLine_CloseApps, options.CommandLine_CloseAppsForce) = false then
          if options.CommandLine_ShowEject=false then //if its true then windows shows its own message
            case EjectErrorCode of
              REMOVE_ERROR_UNKNOWN_ERROR:   ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_UNKNOWN_ERROR);
              REMOVE_ERROR_DRIVE_NOT_FOUND: ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_DRIVE_NOT_FOUND);
              REMOVE_ERROR_DISK_IN_USE:     ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_DISK_IN_USE);
              REMOVE_ERROR_NO_CARD_MEDIA:   ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_NO_CARD_MEDIA);
              REMOVE_ERROR_WINAPI_ERROR:    ShowMessage( '(' + options.CommandLine_Param_RemoveLetter + ':) ' + str_REMOVE_ERROR_WINAPI_ERROR);
            end;
      finally
        Ejector.free;
      end;
    end;

    if options.MobileMode then //cleanup
      CreateCleanupBatFileAndRun;

    exit;
  end;

  //*******************Disable this before release !!!!*************************
  ReportMemoryLeaksOnShutdown:=true;
  //****************************************************************************


  Application.Title := 'USB Disk Ejector';
  Application.CreateForm(TMainfrm, Mainfrm);
  Application.CreateForm(TAboutfrm, Aboutfrm);
  
  if options.StartAppMinimised then
    Mainfrm.WindowState:=wsMinimized;

  if options.PreserveWindowLocation then
    mainfrm.Position:=poDesigned
  else
    mainfrm.Position:=poScreenCenter;
   
  Application.CreateForm(TOptionsfrm, Optionsfrm);
  Application.Run;
end.
