 {
******************************************************
  USB Disk Ejector
  Copyright (c) 2006 - 2008 Ben Gorman
  Http://quick.mixnmojo.com
******************************************************
}
{
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}


{
BEFORE RELEASE:
  DISABLE ReportMemoryLeaksOnShutdown in project's .dpr
  Change build configuration from debug to release
  Update readme
  Compress with UPX
  Update version string in uDiskEjectConst
}

{
Added:
  Firewire support - in gui + command line
  Autosize window - resize doesnt go behind taskbar - sizes up if necessary - always stays on screen. Smart resizing
  Autosize option
  Detects card readers
  Card reader polling
  Ejects card by default  - not the device
  Fixed options XP font size
  Docking - will resize correctly and stay in corners
  Different icons - card reader/reader with card in - firewire drive
  Double right clicking opens explorer window
  Better notifications - for different types of removal problem
  Notifications - when eject is successful
  Closes explorer windows before eject - no more vista problems
  Successful eject ballon tips added
  Closes running apps - ask or force - NOT if app has file open from drive
  New - no disks found icon
  Tray - right click removal of devices
  Removed 'website' link on main form
  Added eject by right click menu in tray
  Hotkeys - eject by drive name (with wildcard support), drive letter, bring to front
  Threads - stop very rare issue where device with many partitions or card reader device supporting multiple devices - not all drives were detected

  Occasionally - can eject a card reader device before it shows up and is detected as card reader - before all card drives get installed
  Need testing from someone who has balloon hints disabled on their system

TODO Before Release:
  COMMAND LINE:
        Get rid of /SILENT switch - but have noballoon option on command line?
        Need to separate gui and command line modes:
        Should be no switches for GUI Mode features - all controlled by options now?
        All options stored in the cfg file should be ignored on command line - only switches?
        Problem (command line?) - if balloons disabled and using own messages - if eject fails - then no message given
        Need switch for command line card reader device - will eject card by default but not reader
        All need looking at and reworking - needs to be redesigned
        Mobile mode - needs more switches to accomodate new options
        Need to fix in start in mobile mode - need switch for eject card or card reader device
        
  HOTKEYS:
        need to know when restoring from ini - rebuildhotkeys - if hotkey active or not + to show this in options
        Hotkey feature needs fixing up and completing
        
  OTHER:
        Card reader detection fails - if file is open from card or explorer window to card is open
        Disable notifications - disabled
        Use windows' notifications - doesnt work if show balloon hints is enabled - is this option really necessary anyway? The apps messages are far better.
        Tabstop order in options form
        Cant tab to more on main form
        Position - lock to corner of screen?
        What if balloon hints are disabled?  - How will notifications get through then? Need messagebox fallback or other alternative?
        Add global messaging unit or procedure - no more plain showmessage or balloon hint
        Options dialog needs rewriting - treeview?

Optional/Possibilities/Non-critical:
        See mindmap for full list
        Let you know what processes have been closed when it forces apps to close?
        Wmplayer problem on insert/remove - only on my system? Scans the removable drive for 5-20 seconds when device is inserted stopping ejection.
        Add unicode support - either with tnt controls or Delphi 2009
        Option to set card polling time?
        Timer for ejection? - eg if running from pstart menu - run command to eject stick in 5 secs - gives time to close the menu
        Intercept shutdown/restart message and warn that usb stick is still in the drive. Dont forget it.
        REMOVEALL switch - eject every usb drive it finds?
        Hide partitions from same drive
        Hide certain drives when specified by user?
        Detect/support drives mapped as folder
        Vista - make balloon hints vista style
        What if I sent the WM_DEVICE_CHANGED after a successful ejection? Will it speed things up?
        Since last stable release I've disabled 'program is still running message' when app is minimized- re-enable this?
}

unit formMain;

interface

uses
  Forms, Sysutils, Controls, Classes, Windows, XPMan, ExtCtrls, ImgList,
  graphics, types,
  JvExControls, JvLabel,
  JclSysInfo, JclShell, JwaDBT,
  Menus, PngImageList, VirtualTrees,  

  uVistaFuncs, uDiskEjectConst, uDiskEjectUtils, uDiskEjectOptions,
  uCustomHotKeyManager, uDriveEjector, JvAppInst;

type

  TEventsThread = class(TThread)
  private
  protected
    procedure Execute; override;
  public
  end;

  TMainfrm = class(TForm)
    XPManifest1: TXPManifest;
    Tree: TVirtualStringTree;
    TrayIcon1: TTrayIcon;
    pnlBottom: TPanel;
    PngImageListLarge: TPngImageList;
    popupmenuTray: TPopupMenu;
    popupExit: TMenuItem;
    popupOptions: TMenuItem;
    popupAbout: TMenuItem;
    lblMore: TJvLabel;
    popupEjectMenu: TMenuItem;
    JvAppInstances1: TJvAppInstances;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TreeGetNodeDataSize(Sender: TBaseVirtualTree;
      var NodeDataSize: Integer);
    procedure TreeGetText(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Column: TColumnIndex; TextType: TVSTTextType; var CellText: WideString);
    procedure TreeGetImageIndex(Sender: TBaseVirtualTree; Node: PVirtualNode;
      Kind: TVTImageKind; Column: TColumnIndex; var Ghosted: Boolean;
      var ImageIndex: Integer);
    procedure TreeDblClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TrayIcon1Click(Sender: TObject);
    procedure TreeKeyPress(Sender: TObject; var Key: Char);
    procedure TreePaintText(Sender: TBaseVirtualTree;
      const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
      TextType: TVSTTextType);
    procedure popupExitClick(Sender: TObject);
    procedure popupOptionsClick(Sender: TObject);
    procedure popupmenuTrayPopup(Sender: TObject);
    procedure popupAboutClick(Sender: TObject);
    procedure lblMoreMouseEnter(Sender: TObject);
    procedure lblMoreMouseLeave(Sender: TObject);
    procedure lblMoreClick(Sender: TObject);
    procedure TreeMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WMDeviceChange(var Msg: TWMDeviceChange); message WM_DEVICECHANGE;
    procedure JvAppInstances1Rejected(Sender: TObject);
  private
    fThreadRunning: boolean;
    fChangeMessageCount: integer;
    EventsThread: TEventsThread;
    DrivePopups: array of TMenuItem;
    Procedure MinimizeClick(Sender:TObject);
    Procedure MinimizeToTray;
    procedure FillDriveList;
    procedure CloseProgram; //Use this rather than form.close because this prevents the CloseToTray option stopping it closing
    procedure HotKeyPressed(HotKey: Cardinal; Index: Word);
    procedure ResizeTree;
    procedure OnCardMediaChanged (Sender: TObject);
    procedure DrivePopupMenuHandler(Sender: TObject);
    procedure AddDrivePopups;
    procedure UpdateFormStrings;
    procedure GUIRemoveDrive(DriveLetter: String; RemoveCard: boolean);
  public
  end;

var
  Mainfrm: TMainfrm;
  Ejector: TDriveEjector;
  HotKeys: TCustomHotKeyManager;
  ForceClose: boolean = false; //Used by CloseProgram() to prevent the CloseToTray option stopping the app closing

implementation

uses formOptions, formAbout;      

{$R *.dfm}

procedure TMainfrm.FormCreate(Sender: TObject);
begin
  //Set vista fonts if necessary
  SetDesktopIconFonts(Self.Font);

  //Load strings
  UpdateFormStrings;

  //Resize various fonts (necessary for xp rather than vista)
  tree.ParentFont:=false;
  tree.Font.Size:=10;
  Tree.Header.ParentFont:=true;
  Tree.Header.Font.Size:=8;

  if options.PreserveWindowSize then
  begin
    mainfrm.Height:=options.WindowHeight;
    mainfrm.Width:=options.WindowWidth;
  end;

  if options.PreserveWindowLocation then
  begin
    mainfrm.top:=options.WindowTopPos;
    mainfrm.left:=options.WindowLeftPos;
  end;

  Ejector:=TDriveEjector.Create;

  FillDriveList;

  Application.hintpause:=0800;
  Application.OnMinimize:= MinimizeClick;

  HotKeys:=TCustomHotKeyManager.Create;
  HotKeys.OnHotKeyPressed:=HotKeyPressed;
  Ejector.OnCardMediaChanged:=OnCardMediaChanged;

  Ejector.CardPolling:=Options.CardPolling;
  
  ResizeTree;
end;

procedure TMainfrm.FormDestroy(Sender: TObject);
var
  i: integer;
begin
  if DrivePopups <> nil then
  begin
    for i:=low(DrivePopups) to high(DrivePopups) do
      DrivePopups[i].Free;

    DrivePopups:=nil;
  end;
  
  HotKeys.Free;
  Ejector.Free;
end;

procedure TMainfrm.HotKeyPressed(HotKey: Cardinal; Index: Word);
var
  EjectCard: boolean;
  TempDrive, DriveName: string;
begin
  //Stop hotkeys if options form or about form are showing
  if Optionsfrm.Showing then exit;
  if Aboutfrm.Showing then exit;

  {ShowMessage(HotKeys.HotKeyToText(HotKey, true) + ' ' +
  TCustomHotKey(HotKeys.HotKeys[Index]).HotKeyParam);}

  EjectCard:=true; {If device isnt a card reader then this will be
                    automatically set to false and will do a normal eject}

  case TCustomHotKey(HotKeys.HotKeys[Index]).HotKeyType of
    RestoreApp:             TrayIcon1Click(Mainfrm);

    EjectByDriveLetter:     GUIRemoveDrive(TCustomHotKey(
                                HotKeys.HotKeys[Index]).HotKeyParam, EjectCard);

    EjectByDriveName:       begin
                              DriveName:=TCustomHotKey(HotKeys.HotKeys[Index]).HotKeyParam;
                              TempDrive:=MatchNameToDriveLetter(DriveName);

                              if TempDrive = '' then
                              begin
                                if options.BalloonMessages = true then
                                  if options.ShowWindowsEjectMessage = false then
                                  begin
                                    TrayIcon1.BalloonHint:= '"' + DriveName + '" ' + str_REMOVE_ERROR_NAME_NOT_FOUND;
                                    TrayIcon1.BalloonFlags:=bfError;
                                    TrayIcon1.ShowBalloonHint;
                                  end;
                              end
                              else
                                GUIRemoveDrive(TempDrive, EjectCard);
                            end;

  end;
end;

procedure TMainfrm.JvAppInstances1Rejected(Sender: TObject);
begin
   trayicon1.Visible:=false;
end;

procedure TMainfrm.CloseProgram;
begin
  ForceClose:=true;
  Mainfrm.Close;
end;

procedure TMainfrm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if ForceClose then //Stops CloseToTray option preventing closure if we really need to close the app
  begin
    ForceClose:=false
  end
  else
  if options.CloseToTray then
  begin
    Action:=caNone;
    MinimizeToTray;
  end;

  if options.PreserveWindowSize then
  begin
    options.WindowHeight:=mainfrm.Height;
    options.WindowWidth:=mainfrm.Width;
    options.SaveConfig;
  end;

  if options.PreserveWindowLocation then
  begin
    options.WindowTopPos:=mainfrm.top;
    options.WindowLeftPos:=mainfrm.left;
    options.SaveConfig;
  end;

  if options.MobileMode=false then exit;

  CreateCleanupBatFileAndRun;
end;

procedure TMainfrm.lblMoreClick(Sender: TObject);
var
  pt: TPoint;
begin
  pt:=lblMore.ClientToScreen( Point( 0, lblMore.Height+1 ));
  if assigned( lblMore.popupmenu ) then
  begin
    popupEjectMenu.Visible:=false; //Hide ejection popups when clicking label
    lblMore.popupmenu.popup( pt.x, pt.y );
    popupEjectMenu.Visible:=true;
  end;

 //popupmenutray.Popup(mainfrm.Left + pnlBottom.Left, mainfrm.Top + pnlBottom.Top + pnlBottom.Height);
end;

procedure TMainfrm.lblMoreMouseEnter(Sender: TObject);
begin
  lblMore.Font.style:=[fsunderline];
end;

procedure TMainfrm.lblMoreMouseLeave(Sender: TObject);
begin
  lblMore.Font.style:=[];
end;

Procedure TMainfrm.MinimizeClick(Sender:TObject);
begin
  if Options.MinimizeToTray = false then exit;

  MinimizeToTray;
end;

procedure TMainfrm.MinimizeToTray;
begin

  Hide;
  if IsWindowVisible(Application.Handle) then //hide the taskbar button
    ShowWindow(Application.Handle, SW_HIDE);
    //TrayIcon1.Visible:= True;

  {if (MinimizeBalloonShown=true) or (options.BalloonMessages=false) then
    //TrayIcon1.BalloonHint:=''
  else
  begin
    TrayIcon1.BalloonHint:=strMinimize;
    TrayIcon1.BalloonFlags:=bfInfo;
    //TrayIcon1.ShowBalloonHint;
    MinimizeBalloonShown:=true;
  end;}
end;

procedure TMainfrm.OnCardMediaChanged(Sender: TObject);
begin
  //beep;
  tree.FullExpand;
end;

procedure TMainfrm.popupAboutClick(Sender: TObject);
begin
  Aboutfrm.ShowModal;
end;

procedure TMainfrm.popupExitClick(Sender: TObject);
begin
  CloseProgram;
end;

procedure TMainfrm.popupmenuTrayPopup(Sender: TObject);
var
  i: integer;
begin
  if (fsModal in Aboutfrm.FormState) or (fsModal in Optionsfrm.FormState) then
  begin
    for I := 0 to popupmenuTray.Items.Count - 1 do
      popupmenuTray.Items[i].Enabled:=false;

    popupExit.Enabled:=true;
  end
  else
  begin
    for I := 0 to popupmenuTray.Items.Count - 1 do
      popupmenuTray.Items[i].Enabled:=true;
  end;

  //If there are no drive popups then disable the submenu
  if Length(DrivePopups) > 0 then
    popupEjectMenu.Enabled:=true
  else
    popupEjectMenu.Enabled:=false;

end;

procedure TMainfrm.popupOptionsClick(Sender: TObject);
begin
  Optionsfrm.showmodal;
end;

procedure TMainfrm.GUIRemoveDrive(DriveLetter: String; RemoveCard: boolean);
var
  SilentSwitch, CloseAppsSwitch, CloseAppsForceSwitch: string;
  EjectError: integer;
begin
  if options.BalloonMessages=false then
    SilentSwitch:='/SILENT '
  else
    SilentSwitch:=''; //no silent switch

  if options.CloseRunningApps then
    CloseAppsSwitch:='/CLOSEAPPS '
  else
    CloseAppsSwitch:='';

  if options.ForceAppsClose then
    CloseAppsForceSwitch:='/CLOSEAPPSFORCE '
  else
    CloseAppsForceSwitch:='';

  //Check if trying to eject drive that its running from
  if DriveLetter = options.DriveRunningFrom then
  begin
    StartInMobileMode(SilentSwitch + '/NOSAVE ' + options.CommandLine_Param_ShowEject + CloseAppsSwitch + CloseAppsForceSwitch + '/REMOVELETTER ' + options.DriveRunningFrom);
    CloseProgram;
    Exit;
  end;

  //Otherwise just eject
  tree.Enabled:=false;
  if Ejector.RemoveDrive(DriveLetter, EjectError, options.ShowWindowsEjectMessage, RemoveCard, options.CloseRunningApps, options.ForceAppsClose) = false then
  begin;
    tree.Enabled:=true;
    if options.BalloonMessages = true then
      if options.ShowWindowsEjectMessage = false then  //If true then windows shows its own error messagebox
      begin
        case EjectError of
          REMOVE_ERROR_UNKNOWN_ERROR:   TrayIcon1.BalloonHint:= '(' + DriveLetter + ':) ' + str_REMOVE_ERROR_UNKNOWN_ERROR;
          REMOVE_ERROR_DRIVE_NOT_FOUND: TrayIcon1.BalloonHint:= '(' + DriveLetter + ':) ' + str_REMOVE_ERROR_DRIVE_NOT_FOUND;
          REMOVE_ERROR_DISK_IN_USE:     TrayIcon1.BalloonHint:= '(' + DriveLetter + ':) ' + str_REMOVE_ERROR_DISK_IN_USE;
          REMOVE_ERROR_NO_CARD_MEDIA:   TrayIcon1.BalloonHint:= '(' + DriveLetter + ':) ' + str_REMOVE_ERROR_NO_CARD_MEDIA;
          REMOVE_ERROR_WINAPI_ERROR:    TrayIcon1.BalloonHint:= '(' + DriveLetter + ':) ' + str_REMOVE_ERROR_WINAPI_ERROR;

        end;
        TrayIcon1.BalloonFlags:=bfError;
        TrayIcon1.ShowBalloonHint;
      end;

    exit;
  end
  else //eject successful
  begin
    //tree.Enabled:=true; //Unnecessary but may stop the rare occasions when tree doesnt get re-enabled - but could also cause access violations?

    if options.BalloonMessages = true then
    begin
      TrayIcon1.BalloonHint:='(' + DriveLetter + ':) ' + str_REMOVE_SUCCESSFUL;
      TrayIcon1.BalloonFlags:=bfInfo;
      TrayIcon1.ShowBalloonHint;
    end;
  end;

  if RemoveCard then //No WMDeviceChange fired for cards
  begin
    ResizeTree;
    tree.Enabled:=true;
  end;

  if options.AfterEject= int_AFTER_EJECT_DO_CLOSE then CloseProgram;
  if options.AfterEject= int_AFTER_EJECT_DO_MINIMIZE then Application.Minimize;

  //If eject succeeds then tree enabling + updating is done in WMDeviceChange

end;

procedure TMainfrm.ResizeTree;
var
  i, NodeWidth, NodesHeight: integer;
  TempNode, PrevNode: pVirtualNode;
  statictext: string;
const
  VertFormPadding: integer = 100;
  HorizFormPadding: integer = 140; //This could be wrong
begin
  if Tree.RootNodeCount = 0 then exit;
  if Options.AutoResize = false then exit;


  NodesHeight:=Tree.NodeHeight[tree.GetFirst] * Tree.RootNodeCount; //All nodes same height

  NodeWidth:=0;
  TempNode:=tree.GetFirst;
  for I := 0 to Tree.RootNodeCount - 1 do
  begin
    if Ejector.DrivesCount > 0 then
      statictext:=Ejector.RemovableDrives[TempNode.Index].VolumeName
    else
      statictext:='';

    if mainfrm.Canvas.TextWidth(tree.Text[TempNode, 0] + Statictext)  > NodeWidth then
      NodeWidth := mainfrm.Canvas.TextWidth(tree.Text[TempNode, 0] + Statictext);

    prevNode:=TempNode;
    TempNode:=Tree.GetNext(PrevNode);
  end;

 //Correct width and check if already docked at right
  if mainfrm.Left = screen.Width - mainfrm.Width then
  begin
    mainfrm.Width:=NodeWidth + HorizFormPadding;
    mainfrm.Left:= screen.Width - mainfrm.Width
  end
  else
    mainfrm.Width:=NodeWidth + HorizFormPadding;

  //Correct height and check if already docked at bottom
  if mainfrm.Top = screen.Height - mainfrm.Height - GetTaskBarHeight then
  begin
    mainfrm.Height:=NodesHeight + VertFormPadding;
    mainfrm.top:= screen.Height - mainfrm.Height - GetTaskBarHeight;
  end
  else
    mainfrm.Height:=NodesHeight + VertFormPadding;




  //Check and correct position if resolution different
  if mainfrm.Left < 0 then
    mainfrm.Left:=0;

  if mainfrm.Left + mainfrm.Width > screen.Width then
    mainfrm.Left:=screen.Width - mainfrm.Width;

  if mainfrm.Top < 0 then
    mainfrm.Top:=0;
   

  //Stop form resizing so its below taskbar if its docked at the bottom
  //Also corrects for different resolution - if it was previously docked at bottom
  if (mainfrm.Top + mainfrm.Height) > (screen.Height - GetTaskBarHeight)  then
    mainfrm.Top := screen.Height - mainfrm.Height - GetTaskBarHeight;
end;

procedure TMainfrm.TrayIcon1Click(Sender: TObject);
begin
  //SendMessage(handle, WM_SYSCOMMAND, SC_RESTORE, 0);
  Application.Restore;  {restore the application}
  If WindowState = wsMinimized then WindowState := wsNormal;  {Reset minimized state}
  visible:=true;
  //TrayIcon1.Visible:= False;
  SetForegroundWindow(Application.Handle); {Force form to the foreground }
end;

procedure TMainfrm.TreeDblClick(Sender: TObject);
var
  RemoveCard: boolean;
  DriveLetter: String;
begin
  if Ejector.DrivesCount = 0 then exit;

  if Tree.SelectedCount = 0 then exit;

  if fThreadRunning then exit;
  
  //TODO - make switch for this and add it to startinmobilemode below
  //TODO - sort this out for hotkey press too
  RemoveCard:=Ejector.RemovableDrives[Tree.focusednode.Index].IsCardReader;

  DriveLetter:=Ejector.RemovableDrives[Tree.focusednode.Index].DriveLetter;

  GUIRemoveDrive(DriveLetter, RemoveCard);
end;

procedure TMainfrm.WMDeviceChange(var Msg: TWMDeviceChange);
begin
  //Look for volumes being added or removed
  if (Msg.Msg = WM_DEVICECHANGE) and
      (((Msg.Event = DBT_DEVICEARRIVAL) and
      (PDevBroadcastHeader(Msg.dwData).dbcd_devicetype = DBT_DEVTYP_VOLUME)) or
      (Msg.Event = DBT_DEVICEREMOVECOMPLETE)) then
    begin
      if FThreadRunning then
      begin
        inc(fChangeMessageCount);
        outputdebugstring(pansichar('THREAD RUNNING - MESSAGE COUNT = ' + inttostr(fChangeMessageCount)));
      end
      else
      begin
        fChangeMessageCount:=1;
        tree.Enabled:=false;
        EventsThread:=TEventsThread.Create(true);
        FThreadRunning:=true;
        EventsThread.FreeOnTerminate:=true;
        EventsThread.Resume;
      end;
    end;
end;

procedure TMainfrm.DrivePopupMenuHandler(Sender: TObject);
var
  DriveLetter: string;
  EjectCard: boolean;
begin
  with Sender as TMenuItem do
  begin
    DriveLetter:=Ejector.RemovableDrives[tag].DriveLetter;
    EjectCard:=Ejector.RemovableDrives[tag].IsCardReader;
    GUIRemoveDrive(DriveLetter, EjectCard);
  end;
end;

procedure TMainfrm.FillDriveList;
begin
  Tree.BeginUpdate;

  if Ejector.DrivesCount = 0 then
  begin
    Tree.RootNodeCount:=1
  end
  else
  begin
    Tree.RootNodeCount:=Ejector.DrivesCount;
    Tree.FocusedNode:=Tree.GetFirst;
    Tree.Selected[Tree.GetFirst]:=true;
  end;

  AddDrivePopups;
                                           
  Tree.EndUpdate;
end;

procedure TMainfrm.AddDrivePopups;
var
  i: integer;
begin
  if DrivePopups <> nil then
    for i:=low(DrivePopups) to high(DrivePopups) do
      DrivePopups[i].Free;
      
  if Ejector.DrivesCount = 0 then
  begin
    DrivePopups:=nil;
    exit;
  end;
  
  SetLength(DrivePopups, Ejector.DrivesCount);
  for i:=low(DrivePopups) to high(DrivePopups) do
  begin
    DrivePopups[i]:=TMenuItem.Create(Self);
    DrivePopups[i].Caption:=Ejector.RemovableDrives[i].DriveLetter + ':   ' +
      Ejector.RemovableDrives[i].VendorId + ' ' + 
      Ejector.RemovableDrives[i].ProductID;

    if Ejector.RemovableDrives[i].VolumeName > '' then
      DrivePopups[i].Caption:=DrivePopups[i].Caption + '  (' +
      Ejector.RemovableDrives[i].VolumeName + ')';


    DrivePopups[i].Tag:=i; //Store drive index for eject later   
    popupMenuTray.Items[2].add(DrivePopups[i]); //Add to the eject submenu
    DrivePopups[i].OnClick:=DrivePopupMenuHandler;
    //DrivePopups[i].ImageIndex:=;  
  end;
end;

procedure TMainfrm.TreeGetImageIndex(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Kind: TVTImageKind; Column: TColumnIndex;
  var Ghosted: Boolean; var ImageIndex: Integer);
begin
  if Ejector.DrivesCount = 0 then
    ImageIndex:=1
  else
  if pos('IPOD', Uppercase(Ejector.RemovableDrives[node.index].ProductID )) > 0  then
    ImageIndex:=2
  else
  if Ejector.RemovableDrives[node.index].BusType = 4 then //firewire
    ImageIndex:=5
  else
  if Ejector.RemovableDrives[node.index].IsCardReader then
    if Ejector.RemovableDrives[node.index].CardMediaPresent then
      ImageIndex:=4
    else
      ImageIndex:=3

  else
    ImageIndex:=0;
end;

procedure TMainfrm.TreeGetNodeDataSize(Sender: TBaseVirtualTree;
  var NodeDataSize: Integer);
begin
  NodeDataSize := 0;
end;

procedure TMainfrm.TreeGetText(Sender: TBaseVirtualTree;
  Node: PVirtualNode; Column: TColumnIndex; TextType: TVSTTextType;
  var CellText: WideString);
begin
  if Ejector.DrivesCount = 0 then
  case texttype of
    ttNormal: CellText:= str_No_Drive;
    ttStatic: CellText:= '';
  end
  else
  case texttype of
    ttNormal: CellText:='(' + Ejector.RemovableDrives[Node.Index].DriveLetter + ':) ' + Ejector.RemovableDrives[Node.Index].VendorId + ' ' + Ejector.RemovableDrives[Node.Index].ProductID;
    ttStatic: CellText:= Ejector.RemovableDrives[Node.Index].VolumeName;
  end;

end;

procedure TMainfrm.TreeKeyPress(Sender: TObject; var Key: Char);
begin
  if key = #13 then
    Tree.OnDblClick(Mainfrm);
end;

procedure TMainfrm.TreeMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Ejector.DrivesCount = 0 then exit;
  if Tree.SelectedCount = 0 then exit;

  if (ssDouble in Shift) and (Button = mbRight) then
    ShellExec(0, 'open', Ejector.RemovableDrives[Tree.focusednode.Index].DriveLetter + ':\', '', '', SW_SHOWNORMAL);
end;

procedure TMainfrm.TreePaintText(Sender: TBaseVirtualTree;
  const TargetCanvas: TCanvas; Node: PVirtualNode; Column: TColumnIndex;
  TextType: TVSTTextType);
begin
  case TextType of
    ttStatic: TargetCanvas.Font.Style:=[fsBold];
  end;
end;

procedure TMainfrm.UpdateFormStrings;
begin
  mainFrm.Caption               := str_Main_Caption;
  lblMore.Caption               := str_Main_Bottom_Popup;
  tree.Header.Columns[0].Text   := str_Main_Tree_Header;
  //tree.Hint                     := str_Tree_Hint;
  popupAbout.Caption            := str_Main_Popup_About;
  popupOptions.Caption          := str_Main_Popup_Options;
  popupEjectMenu.Caption        := str_Main_Popup_Eject;
  popupExit.Caption             := str_Main_Popup_Exit;
end;


//Event thread
procedure TEventsThread.Execute;
var
  Count: integer;
begin
  Count:=0;
  repeat
    Ejector.RescanAllDrives;
    mainfrm.FillDriveList;
    inc(count);
  until Count >= mainfrm.fChangeMessageCount;

  mainfrm.tree.Enabled:=true;
  mainfrm.ResizeTree;
  mainfrm.FThreadRunning:=false;
end;

end.
