 {
******************************************************
  USB Disk Ejector
  Copyright (c) 2006, 2007, 2008 Ben Gorman
  Http://quick.mixnmojo.com
******************************************************
}
{
  This program is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 2
  of the License, or (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

unit uDiskEjectUtils;

interface

uses Classes, sysutils, windows, forms, jclsysinfo, jclfileutils, jclshell,
     dialogs,
     uDiskEjectConst, uDriveEjector;

procedure CreateCleanupBatFileAndRun;
procedure StartInMobileMode(Parameters: string);
function GetTaskBarHeight: integer;
function MatchNameToDriveLetter(Name: string): string;

implementation

procedure CreateCleanupBatFileAndRun;
var
  tmp: TStringList;
  fname: string;
begin
  fName:=IncludeTrailingPathDelimiter( Getwindowstempfolder)  + 'USB_Eject_Cleanup.bat';
  tmp := TStringList.Create;
  tmp.Add(':redo');
  tmp.Add(Format('@del "%s"', [Application.ExeName]));
  tmp.Add('if EXIST "'+Application.ExeName+'" GOTO redo');
  tmp.Add(Format('@del "%s"', [fname]));
  tmp.SaveToFile(fname);
  tmp.Free;
  WinExec(pchar(fname), SW_HIDE);
end;

procedure StartInMobileMode(Parameters: string);
var
  Attributes: integer;
begin
  if FileCopy(Application.ExeName, IncludeTrailingPathDelimiter(GetWindowsTempFolder) + extractfilename(application.ExeName), true) then
  begin
    //Check if its read only and if it is - change it so it can be deleted later
    Attributes:=FileGetAttr( IncludeTrailingPathDelimiter(GetWindowsTempFolder) + ExtractFileName(application.ExeName));
    if Attributes and faReadOnly = faReadOnly then
      FileSetAttr(IncludeTrailingPathDelimiter(GetWindowsTempFolder) + ExtractFileName(application.ExeName), Attributes xor faReadOnly);


    ShellExec(0, 'open', IncludeTrailingPathDelimiter(GetWindowsTempFolder) + ExtractFileName(application.ExeName), Parameters,  IncludeTrailingPathDelimiter(GetWindowsTempFolder), SW_SHOWNORMAL);
  end
  else
  begin
    ShowMessage(str_Temp_Folder_Write_Error);
  end;
end;

function MatchNameToDriveLetter(Name: string): string;
var
  i, DrivesCount: integer;
  Ejector: TDriveEjector;
begin
  result:='';

  Ejector:=TDriveEjector.Create;
  try
    DrivesCount:=Ejector.DrivesCount;
    if DrivesCount = 0 then exit;

    if Name[1] = '*' then  //wildcard - partial name match
    begin
      for I := 0 to DrivesCount -1 do
      begin
        if pos(Uppercase(copy(Name, 2, length(name) - 1 )), Uppercase(Ejector.RemovableDrives[i].VendorId + ' ' + Ejector.RemovableDrives[i].ProductID)) <> 0 then //found
        begin
          result:=Ejector.RemovableDrives[i].DriveLetter;
          break;
        end;
      end;
    end
    else
    for I := 0 to DrivesCount -1 do
    begin
      if Uppercase(Name) = Uppercase(Ejector.RemovableDrives[i].VendorId + ' ' + Ejector.RemovableDrives[i].ProductID) then
        result:=Ejector.RemovableDrives[i].DriveLetter;
    end;
  finally
    Ejector.free;
  end;
end;

function GetTaskBarHeight: integer;
var
  hTB: HWND; //taskbar handle
  TBRect: TRect; //taskbar rectangle
begin
  hTB:= FindWindow('Shell_TrayWnd', '');
  if hTB = 0 then
    Result := 0
  else
  begin
    GetWindowRect(hTB, TBRect);
    Result := TBRect.Bottom - TBRect.Top;
  end;
end;

end.
